/******************************************************************************
 ** $Id: Erweitert.java 1017 2016-05-28 20:35:09Z wmh $
 ** Diese Datei ist Bestandteil der Java-Quelltexte des Würfelspiels JaFuffy.
 ** Lauffähig ab Java 7.
 ******************************************************************************
 ** Copyright (C) Wolfgang Hauck <wolfgang.hauck@3kelvin.de>
 ******************************************************************************
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************
 ** Die aktuellste Version von JaFuffy findet sich im Internet unter
 ** <http://jafuffy.3kelvin.de>.
 **
 ** Kommentare, Fehler oder Erweiterungswünsche bitte per E-Mail senden an
 ** <jafuffy@3kelvin.de>.
 ******************************************************************************/
package jafuffy.logik.analyse;

import jafuffy.logik.Analyse;
import jafuffy.logik.Spieler;
import jafuffy.logik.Tabzeile;
import jafuffy.logik.Wuerfel;

/** Erstellt Analysen und berechnet Prognosen für die erweiterte Variante der Spielregeln. */
public class Erweitert extends Klassisch {

    /** Kleine Straße mit der Im-Hieb-Regel. */
    class KleineStrasse extends Klassisch.KleineStrasse {
        /** Zur Serialisierung. */
        private static final long serialVersionUID = -244259498879083805L;

        @Override
        protected void bewerte(Spieler spieler) {
            if (istJokerVorliegend(spieler)) {
                wert = PUNKTE;
            } else {
                super.bewerte(spieler);
            }
        }
    }

    /** Große Straße mit der Im-Hieb-Regel. */
    class GrosseStrasse extends Klassisch.GrosseStrasse {
        /** Zur Serialisierung. */
        private static final long serialVersionUID = -4794832240142053236L;

        @Override
        protected void bewerte(Spieler spieler) {
            if (istJokerVorliegend(spieler)) {
                wert = PUNKTE;
            } else {
                super.bewerte(spieler);
            }
        }
    }

    /** JaFuffy mit den erweiterten Regeln. */
    class JaFuffy extends Klassisch.JaFuffy {
        /** Zur Serialisierung. */
        private static final long serialVersionUID = -1936696859004502372L;

        @Override
        protected void bewerte(Spieler spieler) {
            super.bewerte(spieler);
            if (wert > 0 && spieler.punkte(Tabzeile.JAFUFFY) > 0) {
                wert = spieler.punkte(Tabzeile.JAFUFFY) + JOKER;
            }
        }
    }

    /** Alle Einträge für die erweiterte Variante der Spielregeln als Tabelle zusammengefasst. */
    class Eintragungen extends Analyse.Eintragungen {
        /** Erlaubt Serialisierung. */
        private static final long serialVersionUID = -3746750646308026451L;

        /** Konstruktion der Tabelle. */
        Eintragungen() {
            put(Tabzeile.DREIERPASCH, new Dreierpasch());
            put(Tabzeile.VIERERPASCH, new Viererpasch());
            put(Tabzeile.FULLHOUSE, new FullHouse());
            put(Tabzeile.KLEINESTRASSE, new KleineStrasse());
            put(Tabzeile.GROSSESTRASSE, new GrosseStrasse());
            put(Tabzeile.JAFUFFY, new JaFuffy());
        }
    }

    /** Joker-Bonus. */
    private static final int JOKER = 100;

    /** Zur Serialisierung. */
    private static final long serialVersionUID = -3064026868041038008L;

    /**
     * Konstruktor.
     *
     * @param wuerfel
     *            Würfel, mit denen das Turnier durchgeführt wird.
     */
    public Erweitert(Wuerfel[] wuerfel) {
        super(wuerfel);
    }

    /**
     * @param spieler
     *            Der Spieler, dessen Wurf überprüft wird.
     *
     * @return Ermittelt, ob ein Joker erwürfelt wurde.
     */
    public boolean istJokerVorliegend(Spieler spieler) {
        return paschkarte.get(Paschaufzaehlung.FUENFERPASCH) && spieler.punkte(Tabzeile.JAFUFFY) > 0
                && !spieler.setzbar(Tabzeile.oben(wuerfel[0].augen()));
    }

    /**
     * @param spieler
     *            Der Spieler, dessen Wurf überprüft wird.
     *
     * @return Gibt an, ob ein Zwang zum Setzen vorliegt (JaFuffy erwürfelt, JaFuffy-Feld belegt, oben frei).
     */
    public boolean istSetzzwangGegeben(Spieler spieler) {
        return paschkarte.get(Paschaufzaehlung.FUENFERPASCH) && spieler.punkte(Tabzeile.JAFUFFY) > 0
                && spieler.setzbar(Tabzeile.oben(wuerfel[0].augen()));
    }

    @Override
    protected Analyse.Eintragungen eintragungen() {
        return new Eintragungen();
    }

}
